package jarmuvek;

import IE.Iona.Orbix2._CORBA;
import IE.Iona.Orbix2.CORBA.SystemException;
import java.lang.String;

/**
 * A CORBA dem kliens eleme.
 */
public class JarmuClient 
{

/*
 * Hasznlat: JarmuClient <IIOP> <hostname>
 */
  public static void main(String args[]) {

    String hostname;
    boolean useOrbixProt = true;
   
    if (args.length < 1)  // Orbix protokoll s helyi szerver
        hostname = new String(_CORBA.Orbix.myHost());
    else if (args[0].equals("IIOP"))
    {
        useOrbixProt = false;   // IIOP protokoll
        if (args.length < 2)    //      s helyi szerver
            hostname = new String(_CORBA.Orbix.myHost());
        else                    //      s tvoli szerver
            hostname = new String(args[1]);
    }
    else                  // Orbix protokoll s tvoli szerver 
        hostname = new String(args[0]);
    if (useOrbixProt)
    {     
        _CORBA.IT_BIND_USING_IIOP = false;
    }
/*
 *  Kapcsolat kiptse a szerverrel,
 *  g[i] a tvoli objektumok helyi proxijaira mutat.
 */
    _gepjarmuRef  g[] = new _gepjarmuRef[3];
    
    try {
        g[0] = gepjarmu._bind(":GepjarmuSrv", hostname);
        g[1] = autobusz._bind(":AutobuszSrv", hostname);
        g[2] = teherauto._bind(":TeherautoSrv", hostname);
    }
    catch (SystemException ee) {
        System.out.println(ee.toString());
        System.exit(1);
    }  
/*
 *  A program rdemi rsze
 */  
    try {     
        for ( int i = 0;  i < g.length;  ++i )  {
            System.out.println(g[i].print());
        }
    } 
    catch (SystemException ee) {
        System.out.println(ee.toString());
        System.exit(1);
    }
  } 
}
