import java.awt.*;
import java.awt.event.*;
import java.sql.*;
import java.applet.Applet;

public class JDBCtest extends Applet implements ActionListener {
  Button registerButton=new Button(" Betlt ");
  TextField driver=new TextField();
  Button connectButton=new Button("Megnyit");
  TextField url=new TextField();
  TextField userid=new TextField(10);
  TextField password=new TextField(10);
  TextArea sql=new TextArea();
  TextArea result=new TextArea();
  Checkbox clearCheckbox=new Checkbox("Trl");
  Button execButton=new Button("Vgrehajt");
  Button listButton=new Button("Elrhet tblk");
  Button exitButton=new Button("Bezr");
  Connection con;

  public JDBCtest() {
    setLayout(new BorderLayout());
    Panel panel=new Panel();
    panel.setLayout(new GridLayout(3, 1));
    Panel driverpanel=new Panel();
    driverpanel.setLayout(new BorderLayout());
    driverpanel.add("West", new Label("Meghajtprogram:"));
    driverpanel.add("Center", driver);
    registerButton.addActionListener(this);
    driverpanel.add("East", registerButton);
    panel.add(driverpanel);
    Panel urlpanel=new Panel();
    urlpanel.setLayout(new BorderLayout());
    urlpanel.add("West", new Label("Adatbzis URL:   "));
    urlpanel.add("Center", url);
    urlpanel.add("East", connectButton);
    connectButton.addActionListener(this);
    panel.add(urlpanel);
    Panel passpanel=new Panel();
    passpanel.add(new Label("Felhasznl:"));
    passpanel.add(userid);
    passpanel.add(new Label("Jelsz:"));
    password.setEchoChar('*');
    passpanel.add(password);
    panel.add(passpanel);
    add("North", panel);
    Panel textPanel=new Panel();
    textPanel.setLayout(new GridLayout(2, 1));
    Panel sqlPanel=new Panel();
    sqlPanel.setLayout(new BorderLayout());
    sqlPanel.add("North", new Label("Sql:"));
    sqlPanel.add("Center", sql);
    textPanel.add(sqlPanel);
    Panel resultPanel=new Panel();
    resultPanel.setLayout(new BorderLayout());
    resultPanel.add("North", new Label("Eredmny:"));
    result.setEditable(false);
    result.setFont(new Font("Monospaced", Font.PLAIN, 10));
    resultPanel.add("Center", result);
    textPanel.add(resultPanel);
    add("Center", textPanel);
    Panel buttonPanel=new Panel();
    buttonPanel.add(clearCheckbox);
    execButton.addActionListener(this);
    buttonPanel.add(execButton);
    listButton.addActionListener(this);
    buttonPanel.add(listButton);
    exitButton.addActionListener(this);
    buttonPanel.add(exitButton);
    add("South", buttonPanel);
    validate();
    DriverManager.setLogStream(System.out);
  }
  public static void main (String args[]) {
    JDBCtest myJDBCtest=new JDBCtest();
    Frame frame=new Frame("JDBCtest alkalmazs");
    frame.add("Center", myJDBCtest);
    frame.setSize(400, 300);
    frame.show();
  }
  private void kiir(String text) {
    if (text.length()==0 && clearCheckbox.getState()) {
       result.setText("");
       return;
    }
    result.append(text+"\n");
  }
  private void SQLhibu(SQLException e) {
    String s=e instanceof SQLException ? "Hiba" : "Figyelmeztets";
    while (e!=null) {
          kiir("SQLState: "+e.getSQLState());
          kiir(s+" szvege: "+e.getMessage());
          kiir(s+" kdja: "+e.getErrorCode());
          if (e instanceof DataTruncation) {
             DataTruncation dt=(DataTruncation)e;
             String ds=". ";
             ds+=dt.getParameter() ? "paramter " : "oszlop ";
             ds+=dt.getRead() ? "olvas" : "r";
             kiir("Adatcsonkts a(z) "+dt.getIndex()+ds+"sakor: "+
                  dt.getDataSize()+" -> "+dt.getTransferSize());
          }
          e=e instanceof SQLException ? e.getNextException():
            ((SQLWarning)e).getNextWarning();
       }
  }

  private void hiba(String s, Exception e) {
    kiir("--- HIBA ---");
    kiir(s+"!");
    kiir(e.toString());
    if (e instanceof SQLException) SQLhibu((SQLException)e);
  }

  private boolean figyu(SQLWarning w) {
    if (w!=null) {
       kiir("--- FIGYELMEZTETS ---\n"+w);
       kiir(w.toString());
       SQLhibu(w);
       return true;
    }
    return false;
  }
  private String formaz(String s, int width) {
    StringBuffer sb;
    if (s==null) sb=new StringBuffer("null");
    else sb=new StringBuffer(s);
    sb.setLength(width);
    while (width>0 && sb.charAt(--width)=='\u0000') sb.setCharAt(width, ' ');
    return sb.toString();
  }
  private void tablakiir(ResultSet rs) throws SQLException {
    int widths[];
    String s="";
    ResultSetMetaData rsmd = rs.getMetaData();
    int numCols = rsmd.getColumnCount();
    widths=new int[numCols];
    for (int i=1; i<=numCols; i++) {
        if (i>1) s+=" ";
        widths[i-1]=Math.max(rsmd.getColumnDisplaySize(i),
                             rsmd.getColumnLabel(i).length());
        s+=formaz(rsmd.getColumnLabel(i), widths[i-1]);
    }
    kiir(s);
    boolean more = rs.next();
    while (more) {
          if (figyu(rs.getWarnings())) rs.clearWarnings();
          s="";
          for (int i=1; i<=numCols; i++) {
              if (i>1) s+=" ";
              s+=formaz(rs.getString(i), widths[i-1]);
          }
          kiir(s);
          more = rs.next();
    }
    if (figyu(rs.getWarnings())) rs.clearWarnings();
    kiir("--- Kirs vge ---");
  }

  public void actionPerformed(ActionEvent evt) {
    kiir("");
    if (evt.getSource()==exitButton) System.exit(0);
    if (evt.getSource()==registerButton) {
       try {
           Driver d=(Driver)Class.forName(driver.getText()).newInstance();
           kiir("Regisztrlt meghajtprogram: "+driver.getText());
           kiir("Verzi: "+d.getMajorVersion()+"."+d.getMinorVersion());
           String s;
           if (!d.jdbcCompliant()) s=" nem ";
           else s=" ";
           kiir("Ez a meghajtprogram"+s+"JDBC-megfelel.");
       } catch (Exception e) {
         hiba("Nem sikerlt a regisztrci", e);
       }
    }

    if (evt.getSource()==connectButton) {
       try {
           String s;
           con=DriverManager.getConnection(url.getText(),
                             userid.getText(), password.getText());
           DatabaseMetaData meta=con.getMetaData();
           kiir("Megnyitott adatbzis cme: "+meta.getURL());
           kiir("Felhasznl azonostja: "+meta.getUserName());
           kiir("Adatbzis tpusa: "+meta.getDatabaseProductName()+
                " "+meta.getDatabaseProductVersion());
           kiir("Felhasznlt meghajtprogram: "+meta.getDriverName()+
                " "+meta.getDriverVersion());
           if (figyu(con.getWarnings())) con.clearWarnings();
       } catch (Exception e) {
         con=null;
         hiba("Nem sikerlt a kapcsolat megnyitsa", e);
       }
    }

    if (evt.getSource()==listButton && con!=null) {
       try {
           tablakiir(con.getMetaData().getTables(null, null, null, null));
       } catch (Exception e) {
         hiba("Nem sikerlt a tblk listzsa", e);
       }
    }
    if (evt.getSource()==execButton && con!=null) {
       try {
           kiir("Vgrehajtand SQL: "+con.nativeSQL(sql.getText()));
           Statement stmt = con.createStatement();
           stmt.execute(sql.getText());
           int rowCount;
           while (true)  {
                 rowCount = stmt.getUpdateCount();
                 if (rowCount >= 0) {
                    kiir("Megvltozott sorok szma = " + rowCount);
                    stmt.getMoreResults();
                    continue;
                 }
                 ResultSet rs = stmt.getResultSet();
                 if (rs != null) {
                    tablakiir(rs);
                    stmt.getMoreResults();
                    continue;
                 }
                 break;
           }
           if (figyu(stmt.getWarnings())) stmt.clearWarnings();
       } catch (Exception e) {
         hiba("Nem sikerlt a vgrehajts", e);
       }
    }
  }
}
