import java.applet.Applet;                                  //appletrshoz kell
import java.awt.*;                             //grafikus komponensek miatt kell
import java.awt.event.*;                             //esemnykezels miatt kell

public class LifeTest extends Applet implements ActionListener {
  final boolean DEBUG=false;                                 //nincs nyomkvets
  Panel buttonPanel=new Panel();                                //gombok panelje
  Button clearButton=new Button("clear");                          //nyomgombok
  Button exitButton=new Button("exit");
  Button validateButton=new Button("validate");
  Button resizeButton=new Button("resize");
  Button repaintButton=new Button("repaint");
  TextArea textArea=new TextArea();                                 //szvegmez
  static int instantCounter;                                   //pldnyszmll
  int instantID;                                                 //pldny szma
  int stepCounter;                                 //lthat kirt lpsek szma
  int blockTime=5;                               //blokkols hossza msodpercben
  boolean blockMain;                                        //main blokkoldik-e
  boolean blockInit;                                        //init blokkoldik-e
  boolean blockStart;                                      //start blokkoldik-e
  boolean blockStop;                                        //stop blokkoldik-e
  boolean blockDestroy;                                  //destroy blokkoldik-e
  boolean blockFinalize;                                //finalize blokkoldik-e
  boolean blockPaint;                                      //paint blokkoldik-e
  boolean blockUpdate;                                    //update blokkoldik-e
  boolean blockAction;                           //actionPerformed blokkoldik-e

  public LifeTest() {                                              //konstruktor
    instantID=++instantCounter;                         //pldnyszm eltrolsa
    buttonPanel.add(resizeButton);                          //fellet felptse
    resizeButton.addActionListener(this);                      //esemnyfigyels
    buttonPanel.add(validateButton);
    validateButton.addActionListener(this);
    buttonPanel.add(clearButton);
    clearButton.addActionListener(this);
    buttonPanel.add(repaintButton);
    repaintButton.addActionListener(this);
    buttonPanel.add(exitButton);
    exitButton.addActionListener(this);
    textArea.setEditable(false);                    //szvegmez nem mdosthat
    setLayout(new BorderLayout());                 //pakolsi stratgia megadsa
    add("North", buttonPanel);                             //gombok fnt lesznek
    add("Center", textArea);                   //tbbi terleten szvegmez lesz
    validate();                                 //grafikus fellet aktualizlsa
    addItem("konstruktor");                              //konstruktor listzsa
  }

  public static void main(String args[]) {                  //alkalmazs indts
    LifeTest myLifeTest=new LifeTest();                          //pldnyosts
    Frame myFrame=new Frame("LifeTest alkalmazs");                 //keretablak
    myFrame.add("Center", myLifeTest);                      //fellet felptse
    myFrame.setSize(300, 200);
    myFrame.validate();
    if (args.length>0) {                              //paramterek feldolgozsa
       String param=args[0];
       int i;
       try {i=1;                                      //els a blokkols hossza?
           myLifeTest.blockTime=Integer.parseInt(param);
       } catch (Exception e) {i=0;}
       param=""; while (i<args.length) param+=args[i++];
       myLifeTest.useParams(param);                  //metdusnevek feldolgozsa
    }
    myFrame.show();                                        //ablak megjelentse
    myLifeTest.addItem("main");                               //main kilistzsa
    myLifeTest.block(myLifeTest.blockMain);
  }

  public void init() {                                      //indts appletknt
    String param;

    if ((param=getParameter("blockTime"))!=null)      //paramterek feldolgozsa
       try {blockTime=Integer.parseInt(param);
       } catch (Exception e) {}
    if ((param=getParameter("blockMethods"))!=null) useParams(param);
    addItem("init"); block(blockInit);                        //init kilistzsa
  }
  public void start() {
    addItem("start"); block(blockStart);                     //start kilistzsa
  }
  public void stop() {
    addItem("stop"); block(blockStop);                        //stop kilistzsa
  }
  public void destroy() {
    addItem("destroy"); block(blockDestroy);                 //destroy listzsa
  }
  public void finalize() {
    addItem("finalize"); block(blockFinalize);                //finalize kirsa
  }
  public void paint(Graphics g) {
    addItem("paint"); block(blockPaint);                     //paint kilistzsa
  }
  public void update(Graphics g) {
    super.update(g);
    addItem("update"); block(blockUpdate);                  //update kilistzsa
  }
  public void actionPerformed(ActionEvent evt) {                //esemnykezels
    if (DEBUG) System.out.println(instantID+". pldny action: "+evt);
    if (evt.getSource()==exitButton) {                                    //exit
       try {System.exit(0);                                      //applet esetn
       } catch (Exception e) {addItem(e.toString());}            //hiba elkapsa
    } else if (evt.getSource()==clearButton) {                           //clear
           textArea.setText(""); stepCounter=0;
    } else if (evt.getSource()==repaintButton) {                       //repaint
           repaint();
    } else if (evt.getSource()==validateButton) {                     //validate
           validate();
    } else if (evt.getSource()==resizeButton) {                         //resize
           resize(getSize().height, getSize().width);
    }
    addItem("actionPerformed"); block(blockAction);//actionPerformed kilistzsa
  }
  private void useParams(String param) {                 //paramter-feldolgozs
    if (DEBUG) System.out.println(instantID+". pldny param: "+param);
    if (blockTime<0) blockTime=0;
    param=param.toLowerCase();
    blockMain=param.indexOf("main")!=-1; blockInit=param.indexOf("init")!=-1;
    blockStart=param.indexOf("start")!=-1; blockStop=param.indexOf("stop")!=-1;
    blockDestroy=param.indexOf("destroy")!=-1;
    blockFinalize=param.indexOf("finalize")!=-1;
    blockPaint=param.indexOf("paint")!=-1;
    blockUpdate=param.indexOf("update")!=-1;    
    blockAction=param.indexOf("action")!=-1;
  }
  private void addItem(String s) {                         //metdus kilistzsa
    s=instantID+". pldny "+(++stepCounter)+". lps: "+s+" meghvsa a "+
      Thread.currentThread()+Thread.currentThread().getThreadGroup()+"-bl.\n";
    System.out.print(s);
    textArea.append(s);                                             //ltmezbe
    textArea.select(textArea.getText().length(),0);                 //begrgets
  }
  private void block(boolean blocking) {                             //blokkols
    if (blocking) {
       long blockEndTime=System.currentTimeMillis()+1000;
       int blockCounter=blockTime;
       while (blockCounter-->0) {                       //msodpercek szmllsa
             if (DEBUG) System.out.println(instantID+". blocked:"+blockCounter);
             while (System.currentTimeMillis()<blockEndTime);
             blockEndTime+=1000;
} } }  }
