/*
 * ClClTest.java -- Egy sszekttets-mentes kliens alkalmazs
 *
 * Ez az alkalmazs csomagot kld az argumentumaiban megadott nev
 * szmtgp megadott sorszm UDP portjra, a csomagban egy sz van, 
 * amit a felhasznl a harmadik argumentumban adhat meg.
 *
 * A programparamterek:
 *
 *  Els    : annak a hosztnak a neve, ahol a szerver fut
 *  Msodik : a szerver UDP portjnak a sorszma
 *  Harmadik: a szervernek tkldend sz
 *
 * Egy plda a futtatsra:
 *
 *  java ClClTest localhost 5678 Szia_Alma! 
 */
import java.io.*;
import java.net.*;

public class ClClTest {

  public static void hasznalati_utasitas() {
      System.out.println("Hasznlat: java ClClTest " +
                         "szmtgpnv portsorszm tkldend-sz");
      System.exit(-1);
  }

  public static void main(String[] args) {

    int server_port = 0;

    try {
      DatagramSocket s = new DatagramSocket(); // kommunikcis vgpont
      if (args.length != 3) hasznalati_utasitas();
      try { server_port = Integer.parseInt(args[1]); }
        catch (NumberFormatException e) { hasznalati_utasitas(); }
      try {// A szerver cme
        InetAddress ip_cim = InetAddress.getByName(args[0]);  
        int uzenet_hossz = args[2].length(); // az zenet hossza
        byte[] uzenet = args[2].getBytes();
        // programparamternek az zenet objektumba msolsa
        // az UDP csomag
        DatagramPacket p = new DatagramPacket(uzenet, uzenet_hossz, 
                                              ip_cim, server_port); 
        s.send(p); // elkldjk a csomagot a kommunikcis vgpontrl
      } catch (UnknownHostException e) 
              { System.err.println("Ismeretlen hoszt!"); }
        catch (IOException e) 
              { System.err.println("Nem sikerlt a klds!"); }
        finally { s.close(); } // megszntetjk a kommunikcis vgpontunkat
    } catch (SocketException e) 
            { System.err.println("UDP port lefoglalsa nem sikerlt!"); }
  }
}
