/*
 * ClSeTest.java -- Egy sszekttets-mentes szerver alkalmazs
 *
 * Ez az alkalmazs csomagot fogad a futtat szmtgp
 * megadott sorszm UDP portjrl, a csomag tartalmat pedig
 * kirja. 
 *
 * A programparamterek:
 *
 *  Els    : a szerver UDP portjnak a sorszma
 *
 * Egy plda a futtatsra:
 *
 *  java ClSeTest 5678
 */

import java.io.*;
import java.net.*;

public class ClSeTest {

  public static void hasznalati_utasitas() {
      System.out.println("Hasznlat: java ClSeTest " +
                         " portsorszm");
      System.exit(-1);
  }
  public static void main(String[] args) {
    int server_port = 0;

    if (args.length != 1) hasznalati_utasitas(); // sok/kevs argumentum
    try { server_port = Integer.parseInt(args[0]); } // szerver port-sorszma
      catch (NumberFormatException e) { hasznalati_utasitas(); }

    try {
      byte[] uzenet = new byte[1500]; // helyet csinlunk az zenetnek
      String szoveg; // hely a Stringg konvertlt zenetnek (szksges,
                     // ugyanis Stringknt akarjuk kiratni, gy  
                     // konvertlni kell majd)

      /* Ltrehozunk egy csomagot, ahova a berkez zenetet tesszk */
      DatagramPacket p = new DatagramPacket(uzenet, uzenet.length);

      /* Ltrehozzuk a szerver kommunikcis vgpontot */
      /* a megadott UDP porton */
      DatagramSocket s = new DatagramSocket(server_port);

      s.receive(p); // vrunk egy csomagot, s a tartalmt beolvassuk p-be
      // a kapott zenet tartalmt Stringg konvertljuk
      szoveg = new String(uzenet, 0, p.getLength()); 
      System.out.println("Fogadtam csomagot a " +       // s kirjuk
                         p.getAddress().getHostName() +
                         " szmtgptl, a " +
                         p.getPort() + " sorszm UDP portrl." +
                         " Az zenet tartalma: " + szoveg);

      s.close();                              // kommunikcis vgpont lezrsa
    } catch (UnknownHostException e) 
            { System.err.println("Ismeretlen hoszt!"); }
      catch (IOException e) 
            { System.err.println("Nem sikerlt a klds!"); }
  }
}
