//                                                                 //
//                Kliens-szerver Demo, 1997.                       //
//                                                                 //
//         Ksztette: Fodor Szabina s Gulys Lszl              //
//                                                                 //
//                                                                 //
//    Mg mindig elg egyszer, de mr tbb krs szimultn        //
//    kiszolglsra alkalmas szerverprogram.                      //
//                                                                 //

//    Az alkalmazs szerver oldala

import java.net.*;
import java.io.*;
import java.util.*;

//  A mg mindig egyszer szerver osztlya
//  A kiszolgls vgtelen ciklusban trtnik.
//  FIGYELEM! Ez egy egyszer plda, biztonsgi krdsekkel nem foglalkozik!

class Server  {
    public static void main(String[] args)  {
        // A kapcsolat szerver felli oldala
        ServerSocket     serverSocket = null;
        boolean          listening    = true;

        // A fogadegysg ltrehozsa    
        try{ serverSocket = new ServerSocket(1234);
           } catch (IOException e)  {
                 System.err.println( "Nem sikerlt rcsatlakozni az " +
                       "1234-es portra: " + e.getMessage() );
                 System.exit(1);
             }
      // Fciklus
        while (listening)  {
            Socket clientSocket = null;
            try{ // A soronkvetkez krs fogadsa 
                 // s a kiszolgl szl elindtsa
                 clientSocket = serverSocket.accept();
                 new ServerThread(clientSocket).start();
               } catch (IOException e)  {
                    System.out.println( "Feldolgozatlan krs az " +
                            "1234-es porton: " + e.getMessage() );
                    continue;
                 }        
        }
        // Ez a szervert lezr rsz, mely ebben a pldban
        // sohasem kerl vgrehajtsra, de ltalban szksg
        // van r.
        try{ serverSocket.close();
           } catch (IOException e)  {
                 System.err.println("Sikertelen kapcsolat-zrs: " 
                       + e.getMessage());
             }
    }
}

//  A krseket kiszolgl szlak osztlya
//  A szerverrel prhuzamosan futva feldolgozza az ahhoz rkezett krst.
class ServerThread extends Thread  {

    // A klienssel kapcsolatot tart objektum
    private    Socket         socket   = null;   
       
    // A klienssel kapcsolatot tart kt csatorna (input- s output stream)
    private    BufferedReader is      = null;
    private    PrintWriter    os      = null;
    
    // Az objektum ltrehozsa. 
    ServerThread(Socket socket)  {
        super("ServerThread");
        this.socket = socket;
    }
  // A tnyleges feldolgozs: az zenetek megismtlst jelenti
    public void run()  {
        try{ // A kommunikci csatorninak (input- s output stream) 
             // ltrehozsa            
             is = new BufferedReader(new InputStreamReader(
                        socket.getInputStream() )   );
             os = new PrintWriter(socket.getOutputStream());
             logEvent("Sikeres kapcsolat.");            
             try{ // Az zenet 
                  String inputLine = is.readLine();     
                  sendMsg("Szerver: " + inputLine);
                } // Jelezzk a kapcsolat esetleges hibjt
                  catch (IOException e) {
                      logEvent("Adattviteli hiba");
                  }
    
             // A kapcsolat lezrsa                  
             if (os!=null) os.close();
             if (is!=null) is.close();
             if (socket!=null) socket.close();
             logEvent("Kapcsolat lezrva");
           } catch (IOException e)  {
                System.out.println("Rendszerhiba: olvassi/rsi hiba");
             }
    }
  // Az adott zenet tovbbtsa a kliensnek
    public void sendMsg(String message) {
        os.println(message); os.flush();        
    }
  // Az adott esemny logolsa
    public void logEvent(String message) {
        // Az aktulis idpont lekrdezse
        Calendar    actDate = Calendar.getInstance();
        // A rszletes dtum s id kirsa
        System.out.print(actDate.get(Calendar.YEAR) + ".");
        System.out.print((actDate.get(Calendar.MONTH)+1) + ".");
        System.out.print(actDate.get(Calendar.DATE) + ", ");
        System.out.print(actDate.get(Calendar.HOUR) + ":");
        System.out.print(actDate.get(Calendar.MINUTE) + ":");
        System.out.print(actDate.get(Calendar.SECOND) + "> ");
        // Az esemny kirsa, a kliens IP-szmnak megadsval
        System.out.println("["+socket.getInetAddress()+"] "+message); 
    }
}
