import java.util.*;
class ElemType { // ltalnosan elem tpus
  final public static int NULL_ELEMENT = -1; // null elem a lellshoz
  int elem;
  static Random rnd = new Random();

  public ElemType(int elem) {
    this.elem=elem;
  }

  public static ElemType newValue() { // ltalnos rtk generls
    return new ElemType(Math.abs(rnd.nextInt()) % 10);
  }
  public static ElemType makeNull() { // null elem generls
    return new ElemType(NULL_ELEMENT);
  }
  public void showValue() { // rtk kirs
    System.out.println("\telement:" + elem);
  }
  public int value() { // rtk lekrdezs
    return elem;
  }
  public String toString() {
     return Integer.toString(elem);
  }
}

class Monitor { // szinkronizlt rutinok a monitorban
  ElemType row[]; // lista
  int first=0,last=0, num_of_elements=0, row_length;

  public Monitor(int row_length) {
    row = new ElemType[this.row_length = row_length];
  }
  public synchronized void putMaterial( Thread th, ElemType e ) {
    while ( num_of_elements == row_length ) {
      System.out.println(th.getName() + " is waiting");
      try { wait(); } catch (InterruptedException ex) {}
    }
    row[last] = e;
    last = (last + 1) % row_length;
    num_of_elements++;
    notify();
  }
  public synchronized ElemType getMaterial( Thread th ) {
    ElemType e;
    while ( num_of_elements == 0 ) {
      System.out.println(th.getName() + " is waiting");
      try { wait(); } catch (InterruptedException ex) {}
    }
    e = row[first];
    first = (first + 1) % row_length;
    num_of_elements--;
    notify();
    return e;
  }
}

class Producer extends Thread { // termel
  Monitor monitor;
  ElemType e;
  int made_elements = 0, max_elements;
  Random rnd = new Random();

  public Producer(String name, Monitor monitor, int max_elements) {
    super(name);
    this.monitor = monitor;
    this.max_elements = max_elements;
    e=ElemType.newValue();  // els elem generlsa
  }
  public void run() { // termels
    while ( e.value() != ElemType.NULL_ELEMENT ) { // amg nincs null elem
      try {sleep(Math.abs(rnd.nextInt()) % 1000);}
          catch (InterruptedException ex) {}
      monitor.putMaterial( this, e );
      System.out.println( getName() + ":\t" + e.toString() );
      if (made_elements < max_elements) {
        e=ElemType.newValue();
        made_elements++;
      }
      else {
        e=ElemType.makeNull();
      }
    }
    monitor.putMaterial(this, e); //NULL_ELEMNT jelzi a vget
  }
}

class Consumer extends Thread { // fogyaszt
  Monitor monitor;
  ElemType e;
  Random rnd = new Random();

  public Consumer(String name, Monitor monitor) {
    super(name);
    this.monitor = monitor;
  }
  public void run() { // fogyaszts, amg van rtelmes elem
    while (true) {
      try {sleep(Math.abs(rnd.nextInt()) % 1000);}
          catch (InterruptedException ex) {}
      e = monitor.getMaterial( this );
      if (e.value() == ElemType.NULL_ELEMENT) break; 
      System.out.print( getName() );
      e.showValue();
    }
  }
}

public class WaitNotify {
  public static void main(String s[]) {
    Monitor monitor = new Monitor(5);
    Producer producer = new Producer("Producer", monitor, 15);
    Consumer consumer = new Consumer("Consumer", monitor);
    producer.start();
    consumer.start();
  }
}
